Name:           blockerbugs
# NOTE: if you update version, *make sure* to also update
# `blockerbugs/__init__.py` and `docs/source/conf.py`
Version:        0.5.0
Release:        1%{?dist}
Summary:        Fedora QA Blocker Tracking Application

License:        GPLv2+
URL:            https://pagure.io/fedora-qa/blockerbugs
Source0:        https://releases.pagure.org/fedora-qa/blockerbugs/blockerbugs-%{version}.tar.gz

BuildArch:      noarch

Requires:       python-flask
Requires:       python-flask-sqlalchemy
Requires:       python-flask-wtf
Requires:       python-fedora
Requires:       python-fedora-flask
Requires:       python-alembic
Requires:       python-psycopg2
Requires:       python-bugzilla >= 1.1.0
Requires:       python-flask-admin
Requires:       python-iso8601
Requires:       python-openid
Requires:       python-openid-cla
Requires:       python-openid-teams
Requires:       python-cssmin
Requires:       python-sqlalchemy
Requires:       uglify-js
Requires:       koji
BuildRequires:  koji
BuildRequires:  pytest
BuildRequires:  python-devel
BuildRequires:  python-setuptools
BuildRequires:  python-munch
BuildRequires:  python-dingus
BuildRequires:  python-flask
BuildRequires:  python-flask-sqlalchemy
BuildRequires:  python-flask-admin
BuildRequires:  python-fedora-flask
BuildRequires:  python-mock
BuildRequires:  python-koji
BuildRequires:  python-sqlalchemy
BuildRequires:  python-sphinx
BuildRequires:  python-bugzilla
BuildRequires:  python-iso8601

# There are no python-dingus builds for el6 or epel7
%if 0%{?fedora}
BuildRequires:  python-dingus
%endif

%description
The blocker tracking app is a web front end to the currently proposed blocker
and freeze exception bugs for Fedora releases under development.

%prep
%setup -q

%check
%{__python2} setup.py test

%build
%{__python2} setup.py build
sphinx-build  -b html -d docs/_build/doctrees docs/source docs/_build/html
sphinx-build  -b man -d docs/_build/doctrees docs/source docs/_build/man

%install
rm -rf $RPM_BUILD_ROOT
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# alembic stuff
mkdir -p %{buildroot}%{_datadir}/blockerbugs
cp -r alembic %{buildroot}%{_datadir}/blockerbugs/.
cp alembic.ini %{buildroot}%{_datadir}/blockerbugs/.

# apache config and wsgi stuff
mkdir -p %{buildroot}%{_datadir}/blockerbugs/conf
cp conf/blockerbugs.conf %{buildroot}%{_datadir}/blockerbugs/conf/.
cp conf/blockerbugs.cron.example %{buildroot}%{_datadir}/blockerbugs/conf/.
cp conf/blockerbugs.wsgi %{buildroot}%{_datadir}/blockerbugs/.

# configuration file
mkdir -p %{buildroot}%{_sysconfdir}/blockerbugs
install conf/settings.py.example %{buildroot}%{_sysconfdir}/blockerbugs/settings.py.example

# man page for CLI
mkdir -p %{buildroot}/%{_mandir}/man1/
cp -v docs/_build/man/*.1 %{buildroot}/%{_mandir}/man1/


%pre

# add a user and group mostly for running the cron job
%{_sbindir}/groupadd -r %{name} &>/dev/null || :
%{_sbindir}/useradd  -r -s /sbin/nologin -d %{_datadir}/%{name} -M \
                     -c 'Blocker Tracking App' -g %{name} %{name} &>/dev/null || :

%files
%doc docs/_build/html/*
%doc %{_mandir}/man1/blockerbugs*

%{python2_sitelib}/*

%{_bindir}/blockerbugs
%dir %{_sysconfdir}/blockerbugs
%{_sysconfdir}/blockerbugs/*
%dir %{_datadir}/blockerbugs
%{_datadir}/blockerbugs/*


%changelog
* Tue Jan 8 2019 Frantisek Zatloukal <fzatlouk@redhat.com> - 0.5.0-1
- New Bootstrap based frontend
- Dropped Spins Support
- Removed use of flask-assets
- Preliminary Python 3 Support (Python 2 is still used by default)

* Wed Aug 15 2018 Frantisek Zatloukal <fzatlouk@redhat.com> - 0.4.15-1
- Adapt to Bodhi changes to exit nicely if some Release does not exist in Bodhi
- Removed deprecated flask imports
- Switched to Python 3 compatible print
- Switched from bunch to munch (Python 3 preparations)

* Thu Mar 22 2018 Frantisek Zatloukal <fzatlouk@redhat.com> - 0.4.14-1
- nicer favicon
- change alpha criteria links to basic

* Mon Aug 14 2017 Kamil Páral <kparal@redhat.com> - 0.4.13-1
- Correct update URLs
- Add tab for candidate compose / stable push request text
- project moved to Pagure
- enable release switcher to show more releases

* Tue Nov 8 2016 Tim Flink <tflink@fedoraproject.org> - 0.4.4.12-1
- limit cleanup to specified release (D1049)

* Fri Sep 30 2016 Tim Flink <tflink@fedoraproject.org> - 0.4.4.11-1
- fix bug proposal form (D1017)

* Wed Sep 14 2016 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.4.10-1
- Use unicode instead of str on data passed from forms (D835)
- Prevent openid from caching session on disk (D997)
- Default to the current milestone when proposing a blocker (D974)
- Rebuild CSS and amend docs (D998)

* Wed Apr 27 2016 Tim Flink <tflink@fedoraproject.org> - 0.4.4.9-1
- don't consider previous release and 0-day blockers 'proposed' (D829)

* Tue Apr 26 2016 Tim Flink <tflink@fedoraproject.org> - 0.4.4.8-1
- Fixing alembic revision numbers so there isn't a 'multiple head' situation (D828)

* Tue Apr 26 2016 Tim Flink <tflink@fedoraproject.org> - 0.4.4.7-1
- Allow users to see bugs whose blocker status has chnaged (D22)
- Handle 0-day and stable blockers (D689)

* Tue Dec 1 2015 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.4.6-1
- Be more generic when catching Invalid release exc (D669)

* Thu Nov 5 2015 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.4.5-1
- Fix crashing when syncing release that is not in bodhi (T644)

* Thu Aug 20 2015 Tim Flink <tflink@fedoraproject.org> - 0.4.4.4-1
- Adjusting update sync to work with new data member names in bodhi2 api

* Tue Aug 18 2015 Tim Flink <tflink@fedoraproject.org> - 0.4.4.3-1
- change bodhi client usage to prepare for bodhi2 (T569)

* Thu Jan 22 2015 Tim Flink <tflink@fedoraproject.org> - 0.4.4.1-1
- Actually use the configured URL when connecting to bodhi. (T386)

* Thu Jan 22 2015 Tim Flink <tflink@fedoraproject.org> - 0.4.4.1-1
- Updating some links on landing page
- Making Bodhi URL configurable (T386)

* Wed Jan 14 2015 Tim Flink <tflink@fedoraproject.org> - 0.4.4-1
- updating package to target el7 instead of el6
- several small changes to allow running on el7

* Wed Nov 19 2014 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.3.6-1
- Fix syncing when needinfo has no requestee T373
- HTTP 500 errors on incorrect bugzilla credential entry T358
- Do not hardcode links to release criteria on blocker proposal page T360

* Thu Oct 9 2014 Tim Flink <tflink@fedoraproject.org> - 0.4.3.5-1
- Fixing imports of flask admin to remove warning. T348
- Removing py.test from install_requires so that cli works at install. T349

* Tue Sep 9 2014 Tim Flink <tflink@fedoraproject.org> - 0.4.3.4-1
- Fixing milestone relationship for synced updates. T327
- Adding milestone/current endpoint to API. T328

* Wed Jul 9 2014 Tim Flink <tflink@fedoraproject.org> - 0.4.3.3-1
- updating for use with python-bugzilla 1.1.0

* Thu Feb 27 2014 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.3.2-1
- update to 0.4.3.2

* Thu Feb 13 2014 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.3.1-1
- remove bugzilla cookie code

* Wed Nov 20 2013 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.3-1
- fix for #435

* Thu Nov 14 2013 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.2-1
- update to 0.4.2-1

* Thu Nov 14 2013 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.1.1-1
- add minify command to the cli

* Wed Nov 13 2013 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.1-1
- add python-cssmin as dep

* Tue Nov 12 2013 Martin Krizek <mkrizek@fedoraproject.org> - 0.4.0-1
- update to 0.4.0-1

* Thu Oct 10 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.13-3
- removing status restriction on bugzilla query during sync (#421)

* Tue Oct 1 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.13-2
- removing /var/www/blockerbugs from dirs as it isn't used anymore

* Thu Sep 26 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.13-1
- using bodhi update ID urls where possible (fixes #386)

* Thu Sep 26 2013 Ilgiz Islamgulov <ilgizisl@gmail.com> - 0.3.0.12-1
- added missed GPL headers and

* Tue Sep 24 2013 Ilgiz Islamgulov <ilgizisl@gmail.com> - 0.3.0.11-1
- adding 404 response status code for page not found

* Tue Sep 24 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.10-1
- fixing bugzilla login and fixing filter in the spin admin page

* Tue Sep 24 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.9-1
- adding build information to the spin information returned in the API

* Fri Sep 13 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.8-1
- fixing some bugs in the admin interface

* Fri Sep 13 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.7-1
- adding new flask-admin based admin interface and api auth

* Fri Sep 13 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.6.3-1
- removing need for python-bugzilla cookiefile after review (#414)

* Thu Sep 5 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.6.2-2
- fixing file declarations to remove un-needed dir

* Thu Sep 5 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.6.2-1
- moving python-bugzilla cookiefile to /var/www/blockerbugs

* Thu Sep 5 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.6.1-1
- fixing seliux issue preventing proposal from webui (#414)

* Mon Aug 26 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.6-1
- fixing issues with python 2.6

* Thu Aug 22 2013 Martin Krizek <mkrizek@redhat.com> - 0.3.0.5-3
- Add python-flask-assets and uglify-js as dep

* Fri Aug 16 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.5-2
- adding openid deps and api module to setup.py

* Fri Aug 16 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.5-1
- implementing api for spins, updates and bugs
- improving update sync to be more efficient and not leave orphan updates visable

* Thu Jul 25 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.4-2
- adding python-openid, python-openid-teams, python-openid-cla as deps

* Thu Jul 25 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.4-1
- migrating to fas-openid for authentication (#383)

* Mon Jul 8 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.3-1
- fixing crash on milestone modification (#390)

* Thu May 30 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.2-1
- fixing sync trigger on component rename (#330) and full sync

* Tue Apr 30 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.1-1
- Several minor visual fixes and fixing the admin page rendering

* Tue Apr 23 2013 Tim Flink <tflink@fedoraproject.org> - 0.3.0.0-1
- Made some minor visual changes for 0.3 release

* Thu Apr 11 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.7.4-1
- Added a visually obvious staging configuration

* Thu Apr 11 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.7.3-2
- Added the blockerbugs group for user creation

* Thu Apr 11 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.7.3-1
- Fixed a few minor bugs in the proposal process and cleaned up a template

* Wed Apr 10 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.7.2-1
- Centralized logging setup, changed logger creation and added syslog logger option
- Added blockerbugs user for cron job running

* Fri Mar 29 2013 Martin Krizek <mkrizek@fedoraproject.org> - 0.2.7.1-2
- Added log file location

* Mon Mar 25 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.7.1-1
- Fixed issue with cli utility using incorrect variable names

* Mon Mar 25 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.7.0-1
- Merged in bugzilla account integration and blocker proposal functionality

* Wed Mar 13 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.6.2-2
- Changed el6 build to use sphinx 1.0 for manpage generation support

* Tue Mar 12 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.6.2-1
- Added manpage for blockerbugs cli
- Enabled check for fedora, need build of python-dingus on el6

* Mon Mar 11 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.6.1-3
- Updated default value for bugzilla cookie

* Mon Mar 11 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.6.1-2
- Changed config file generation to installation of example

* Mon Mar 11 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.6.1-1
- New upstream version with fewer dependencies and added example cron job

* Wed Mar 6 2013 Tim Flink <tflink@fedoraproject.org> - 0.2.6-1
- Initial package for the blocker tracking app
